using System;
using System.Data;
using System.Data.SqlClient;
using System.Web;
using System.IO;
using System.Collections;
using System.Text.RegularExpressions;

namespace UUN
{
    /// <summary>
    /// 其它模板的留言列表编译部分
    /// </summary>
    public class 编译扩展_其它模板_留言列表 : 编译扩展接口
    {
        private SqlConnection 连接;
        private HttpContext HC;
        private 编译器 编译器;

        public 编译扩展_其它模板_留言列表(SqlConnection 连接, HttpContext HC, 编译器 编译器)
        {
            this.连接 = 连接;
            this.HC = HC;
            this.编译器 = 编译器;
        }

        private int 其它模板_留言列表_一页显示记录数 = 0;

        public String 开始执行代码()
        {
            编译器.方法库 += @"	private String 当前页面;
	//参数
	private int 留言本ID;
	//其它
	private String 跳页表单项;
	private String _3G跳页表单项;
	private String 查询条件="""";
	private Hashtable 留言本;
	//列表分页
	private int 当前页;
	private int 总页数;
	private int 总记录数;
	private int 一页显示记录数;
	private String 列表跳页(int 页码)
	{
		return Server.HtmlEncode(常用.处理地址(当前页面+""?page=""+页码,访问.用户[""标识""].ToString()));
	}
	private String 生成余下全部地址()
	{
		return """";
	}
	private void 生成留言本()
	{
		留言本=常用.SQL_获取(new SqlCommand(""SELECT * FROM [""+程序.数据表前缀+""其它_留言_留言本]""+(留言本ID==0?"""":"" WHERE [ID]=""+留言本ID),访问.连接));
		if(留言本==null)
			throw new Exception(""留言本不存在"");
		留言本ID=Convert.ToInt32(留言本[""ID""]);
	}
";
            String 返回值 = "";
            返回值 += @"	留言本ID=Convert.ToInt32(Request.QueryString[""ID""]);
	一页显示记录数=获取一页显示记录数();
	跳页表单项=""<postfield name=\""ID\"" value=\""""+留言本ID+""\"" />""+
		""<postfield name=\""""+程序.设置[""标识名称""]+""\"" value=\""""+访问.用户[""标识""]+""\"" />"";
	_3G跳页表单项=""<input type=\""hidden\"" name=\""ID\"" value=\""""+留言本ID+""\"" />""+
		""<input type=\""hidden\"" name=\""""+程序.设置[""标识名称""]+""\"" value=\""""+访问.用户[""标识""]+""\"" />"";
	生成留言本();
	当前页面=程序.安装位置+""" + (编译器.是否WML网页 ? "" : "3G_") + @"GuestBook.aspx"";
";
            返回值 += 生成留言列表条件(true, "");
            返回值 += "\t\t当前页=Convert.ToInt32(Request.QueryString[\"page\"]);\r\n";
            返回值 += "\t\t总记录数=Convert.ToInt32(数量语句.ExecuteScalar());\r\n";
            返回值 += "\t\t总页数=常用.计算总页数(总记录数,一页显示记录数);\r\n";
            返回值 += "\t\t当前页=常用.计算当前页(总页数,当前页);\r\n";

            return 返回值;
        }

        private String 生成留言列表条件(bool 是否数量, String 查询字段)
        {
            String 返回值 = "";
            String 语句名称 = 是否数量 ? "数量语句" : "语句";
            if (是否数量)
                返回值 += @"		查询条件+="" WHERE [留言本ID]=""+留言本ID;
";
            返回值 += "\t\tString " + 语句名称 + "SQL=\"SELECT " + (是否数量 ? "COUNT(ID)" : 查询字段) + " FROM [\"+程序.数据表前缀+\"其它_留言_留言]\"+查询条件;\r\n";
            if (!是否数量)
                返回值 += @"		"+语句名称+ @"SQL+="" ORDER BY [留言时间] DESC"";
";
            返回值 += "\t\tSqlCommand " + 语句名称 + "=new SqlCommand(" + 语句名称 + "SQL,访问.连接);\r\n";
            return 返回值;
        }

        public String 编译公共标签(String 代码)
        {
            switch (代码)
            {
                case "留言本名称":
                    return "\t\t返回值.Append(Server.HtmlEncode(留言本[\"留言本名称\"].ToString()));\r\n";
                case "留言本ID":
                    return "\t\t返回值.Append(留言本ID);\r\n";
                case "当前页":
                    return "\t\t返回值.Append(当前页);\r\n";
                case "总页数":
                    return "\t\t返回值.Append(总页数);\r\n";
                case "总记录数":
                    return "\t\t返回值.Append(总记录数);\r\n";
                default:
                    return "";
            }
        }

        private String 编译模板方法_留言列表(String 保密状态文字, String 回复状态文字, int 字数, String 格式, String 交替格式, String 时间格式, String 空记录代码)
        {
            String 随机值 = 常用.随机字符(8);

            Hashtable 必须字段 = new Hashtable();
            必须字段.Add("序号", "");
            必须字段.Add("留言地址", "ID,留言本ID");
            必须字段.Add("留言本地址", "留言本ID");
            Hashtable 字段代码 = new Hashtable();
            字段代码.Add("序号", "(当前页-1)*一页显示记录数+i+1");
            字段代码.Add("留言地址", @"Server.HtmlEncode(常用.处理地址(程序.安装位置+""" + (编译器.是否WML网页 ? "" : "3G_") + @"L_Message.aspx?GID=""+行[""留言本ID""]+""&ID=""+行[""ID""],访问.用户[""标识""].ToString()))");
            字段代码.Add("留言本地址", @"Server.HtmlEncode(常用.处理地址(程序.安装位置+""" + (编译器.是否WML网页 ? "" : "3G_") + @"GuestBook.aspx?GID=""+行[""留言本ID""],访问.用户[""标识""].ToString()))");
            字段代码.Add("留言本名称", @"Server.HtmlEncode(行[""留言本名称""].ToString())");
            字段代码.Add("标题", @"Server.HtmlEncode(常用.截取字符串(行[""标题""].ToString()," + 字数 + "))");
            字段代码.Add("发表人", @"Server.HtmlEncode(行[""发表人""].ToString())");
            字段代码.Add("留言表情", @"常用.获取留言表情图片(行[""留言表情""].ToString())");
            字段代码.Add("留言内容", @"Server.HtmlEncode(行[""留言内容""].ToString())");
            字段代码.Add("留言时间", @"Convert.ToDateTime(行[""留言时间""]).ToString(""" + 时间格式 + "\")");
            String[] 保密状态数组 = 保密状态文字.Split(new char[] { '|' }, StringSplitOptions.RemoveEmptyEntries);
            字段代码.Add("是否保密", @"Convert.ToBoolean(行[""是否保密""])?@""" + 保密状态数组[0].Replace("\"", "\"\"") + @""":@""" + 保密状态数组[1].Replace("\"", "\"\"") + @"""");
            String[] 回复状态数组 = 回复状态文字.Split(new char[] { '|' }, StringSplitOptions.RemoveEmptyEntries);
            字段代码.Add("是否已回复", @"Convert.ToBoolean(行[""是否已回复""])?@""" + 回复状态数组[0].Replace("\"", "\"\"") + @""":@""" + 回复状态数组[1].Replace("\"", "\"\"") + @"""");
            字段代码.Add("回复内容", @"Server.HtmlEncode(行[""回复内容""].ToString())");
            字段代码.Add("回复时间", @"Convert.ToDateTime(行[""回复时间""]).ToString(""" + 时间格式 + "\")");

            String 查询字段, 行代码;
            查询字段 = 编译器.生成查询字段(格式, 交替格式, 必须字段, 字段代码, out 行代码);

            编译器.方法库 += "\tprivate void 留言列表" + 随机值 + @"()
	{
		if(总记录数<1)
			返回值.Append(@"""+空记录代码.Replace("\"","\"\"")+@""");
";
            编译器.方法库+=生成留言列表条件(false, 查询字段);
            编译器.方法库 += 生成查询结果列表(行代码);

            return "\t\t留言列表" + 随机值 + "();\r\n";
        }
        private String 生成查询结果列表(String 行代码)
        {
            String 返回值 = "";
            返回值 += "\t\tDataSet 数据=new DataSet();\r\n";
            返回值 += "\t\tSqlDataAdapter 填充=new SqlDataAdapter(语句);\r\n";
            返回值 += "\t\t填充.Fill(数据,(当前页-1)*一页显示记录数,一页显示记录数,\"表\");\r\n";
            返回值 += "\t\tfor(int i=0;i<数据.Tables[0].Rows.Count;i++)\r\n";
            返回值 += "\t\t{\r\n";
            返回值 += 行代码;
            返回值 += "\t\t}\r\n";
            返回值 += "\t\t}\r\n";
            return 返回值;
        }

        private String 编译模板方法_列表分页(int ID, String 无分页代码)
        {
            return 编译器.编译内容分页(
                "Content",
                "Page", ID, 无分页代码);
        }

        private String 编译模板方法_分页设置(int 一页显示记录数)
        {
            if (一页显示记录数 > 0)
                其它模板_留言列表_一页显示记录数 = 一页显示记录数;
            return "";
        }

        public String 编译模板方法(String 方法名称, String[] 属性数组)
        {
            switch (方法名称)
            {
                case "_留言列表":
                    return 编译模板方法_留言列表(属性数组[0],
                        属性数组[1],
                        Convert.ToInt32(属性数组[2]),
                        属性数组[3],
                        属性数组[4],
                        (属性数组[5]),
                        属性数组[6]);
                case "列表分页":
                    return 编译模板方法_列表分页(Convert.ToInt32(属性数组[0]),
                        属性数组[1]);
                case "分页设置":
                    return 编译模板方法_分页设置(Convert.ToInt32(属性数组[0]));
                default:
                    return "";
            }
        }

        public String 结束执行代码()
        {
            编译器.方法库 += @"	private int 获取一页显示记录数()
	{
";
            if (其它模板_留言列表_一页显示记录数 == 0)
                编译器.方法库 += "\t\treturn 访问.获取一页显示记录数();\r\n";
            else
                编译器.方法库 += "\t\treturn " + 其它模板_留言列表_一页显示记录数 + ";\r\n";
            编译器.方法库 += @"
	}
";
            return "";
        }
    }
}